/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.CEnumerator;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.datatypes.CEnumeration;
import com.ibm.etools.c.datatypes.DatatypesPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>CEnumeration</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.datatypes.impl.CEnumerationImpl#getEnumerator <em>Enumerator</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CEnumerationImpl extends CIntegralImpl implements CEnumeration {
    /**
     * The cached value of the '{@link #getEnumerator() <em>Enumerator</em>}'
     * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getEnumerator()
     * @generated @ordered
     */
    protected EList enumerator = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CEnumerationImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return DatatypesPackage.eINSTANCE.getCEnumeration();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getEnumerator() {
        if (enumerator == null) {
            enumerator = new EObjectContainmentWithInverseEList(CEnumerator.class, this, DatatypesPackage.CENUMERATION__ENUMERATOR, CPackage.CENUMERATOR__ENUMERATION);
        }
        return enumerator;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case DatatypesPackage.CENUMERATION__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicAdd(otherEnd, msgs);
            case DatatypesPackage.CENUMERATION__ENUMERATOR:
                return ((InternalEList) getEnumerator()).basicAdd(otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case DatatypesPackage.CENUMERATION__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicRemove(otherEnd, msgs);
            case DatatypesPackage.CENUMERATION__ENUMERATOR:
                return ((InternalEList) getEnumerator()).basicRemove(otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CENUMERATION__NAME:
            return getName();
        case DatatypesPackage.CENUMERATION__TD_LANG_TYPED_ELEMENT:
            return getTdLangTypedElement();
        case DatatypesPackage.CENUMERATION__ENUMERATOR:
            return getEnumerator();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CENUMERATION__NAME:
            setName((String) newValue);
            return;
        case DatatypesPackage.CENUMERATION__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            getTdLangTypedElement().addAll((Collection) newValue);
            return;
        case DatatypesPackage.CENUMERATION__ENUMERATOR:
            getEnumerator().clear();
            getEnumerator().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CENUMERATION__NAME:
            unsetName();
            return;
        case DatatypesPackage.CENUMERATION__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            return;
        case DatatypesPackage.CENUMERATION__ENUMERATOR:
            getEnumerator().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CENUMERATION__NAME:
            return isSetName();
        case DatatypesPackage.CENUMERATION__TD_LANG_TYPED_ELEMENT:
            return tdLangTypedElement != null && !tdLangTypedElement.isEmpty();
        case DatatypesPackage.CENUMERATION__ENUMERATOR:
            return enumerator != null && !enumerator.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

} //CEnumerationImpl
