/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.source;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>CBlock</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link com.ibm.etools.c.source.CBlock#getSource <em>Source</em>}</li>
 * <li>{@link com.ibm.etools.c.source.CBlock#getNests <em>Nests</em>}</li>
 * <li>{@link com.ibm.etools.c.source.CBlock#getNested <em>Nested</em>}</li>
 * </ul>
 * </p>
 * 
 * @see com.ibm.etools.c.source.SourcePackage#getCBlock()
 * @model @generated
 */
public interface CBlock extends EObject {
    /**
     * Returns the value of the '<em><b>Source</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Source</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Source</em>' attribute.
     * @see #setSource(String)
     * @see com.ibm.etools.c.source.SourcePackage#getCBlock_Source()
     * @model @generated
     */
    String getSource();

    /**
     * Sets the value of the '
     * {@link com.ibm.etools.c.source.CBlock#getSource <em>Source</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Source</em>' attribute.
     * @see #getSource()
     * @generated
     */
    void setSource(String value);

    /**
     * Returns the value of the '<em><b>Nests</b></em>' container
     * reference. It is bidirectional and its opposite is '
     * {@link com.ibm.etools.c.source.CBlock#getNested <em>Nested</em>}'. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Nests</em>' container reference isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Nests</em>' container reference.
     * @see #setNests(CBlock)
     * @see com.ibm.etools.c.source.SourcePackage#getCBlock_Nests()
     * @see com.ibm.etools.c.source.CBlock#getNested
     * @model opposite="nested"
     * @generated
     */
    CBlock getNests();

    /**
     * Sets the value of the '
     * {@link com.ibm.etools.c.source.CBlock#getNests <em>Nests</em>}'
     * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Nests</em>' container reference.
     * @see #getNests()
     * @generated
     */
    void setNests(CBlock value);

    /**
     * Returns the value of the '<em><b>Nested</b></em>' containment
     * reference list. The list contents are of type
     * {@link com.ibm.etools.c.source.CBlock}. It is bidirectional and its
     * opposite is '
     * {@link com.ibm.etools.c.source.CBlock#getNests <em>Nests</em>}'. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Nested</em>' containment reference list
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Nested</em>' containment reference
     *         list.
     * @see com.ibm.etools.c.source.SourcePackage#getCBlock_Nested()
     * @see com.ibm.etools.c.source.CBlock#getNests
     * @model type="com.ibm.etools.c.source.CBlock" opposite="nests"
     *        containment="true"
     * @generated
     */
    EList getNested();

} // CBlock
