/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.source;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc --> The <b>Package </b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * 
 * @see com.ibm.etools.c.source.SourceFactory
 * @generated
 */
public interface SourcePackage extends EPackage {
    /**
     * The package name. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    String eNAME = "source";

    /**
     * The package namespace URI. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    String eNS_URI = "http:///c/source.ecore";

    /**
     * The package namespace name. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    String eNS_PREFIX = "c.source";

    /**
     * The singleton instance of the package. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    SourcePackage eINSTANCE = com.ibm.etools.c.source.impl.SourcePackageImpl.init();

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.source.impl.CBlockImpl <em>CBlock</em>}' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.source.impl.CBlockImpl
     * @see com.ibm.etools.c.source.impl.SourcePackageImpl#getCBlock()
     * @generated
     */
    int CBLOCK = 2;

    /**
     * The feature id for the '<em><b>Source</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBLOCK__SOURCE = 0;

    /**
     * The feature id for the '<em><b>Nests</b></em>' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBLOCK__NESTS = 1;

    /**
     * The feature id for the '<em><b>Nested</b></em>' containment
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBLOCK__NESTED = 2;

    /**
     * The number of structural features of the the '<em>CBlock</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBLOCK_FEATURE_COUNT = 3;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.source.impl.CCommentImpl <em>CComment</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.source.impl.CCommentImpl
     * @see com.ibm.etools.c.source.impl.SourcePackageImpl#getCComment()
     * @generated
     */
    int CCOMMENT = 0;

    /**
     * The feature id for the '<em><b>Source</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CCOMMENT__SOURCE = CBLOCK__SOURCE;

    /**
     * The feature id for the '<em><b>Nests</b></em>' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CCOMMENT__NESTS = CBLOCK__NESTS;

    /**
     * The feature id for the '<em><b>Nested</b></em>' containment
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CCOMMENT__NESTED = CBLOCK__NESTED;

    /**
     * The number of structural features of the the '<em>CComment</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CCOMMENT_FEATURE_COUNT = CBLOCK_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.source.impl.CStatementImpl <em>CStatement</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.source.impl.CStatementImpl
     * @see com.ibm.etools.c.source.impl.SourcePackageImpl#getCStatement()
     * @generated
     */
    int CSTATEMENT = 1;

    /**
     * The feature id for the '<em><b>Source</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSTATEMENT__SOURCE = CBLOCK__SOURCE;

    /**
     * The feature id for the '<em><b>Nests</b></em>' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSTATEMENT__NESTS = CBLOCK__NESTS;

    /**
     * The feature id for the '<em><b>Nested</b></em>' containment
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSTATEMENT__NESTED = CBLOCK__NESTED;

    /**
     * The number of structural features of the the '<em>CStatement</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSTATEMENT_FEATURE_COUNT = CBLOCK_FEATURE_COUNT + 0;

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.source.CComment <em>CComment</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CComment</em>'.
     * @see com.ibm.etools.c.source.CComment
     * @generated
     */
    EClass getCComment();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.source.CStatement <em>CStatement</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CStatement</em>'.
     * @see com.ibm.etools.c.source.CStatement
     * @generated
     */
    EClass getCStatement();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.source.CBlock <em>CBlock</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CBlock</em>'.
     * @see com.ibm.etools.c.source.CBlock
     * @generated
     */
    EClass getCBlock();

    /**
     * Returns the meta object for the attribute '
     * {@link com.ibm.etools.c.source.CBlock#getSource <em>Source</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for the attribute '<em>Source</em>'.
     * @see com.ibm.etools.c.source.CBlock#getSource()
     * @see #getCBlock()
     * @generated
     */
    EAttribute getCBlock_Source();

    /**
     * Returns the meta object for the container reference '
     * {@link com.ibm.etools.c.source.CBlock#getNests <em>Nests</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for the container reference '<em>Nests</em>'.
     * @see com.ibm.etools.c.source.CBlock#getNests()
     * @see #getCBlock()
     * @generated
     */
    EReference getCBlock_Nests();

    /**
     * Returns the meta object for the containment reference list '
     * {@link com.ibm.etools.c.source.CBlock#getNested <em>Nested</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for the containment reference list '
     *         <em>Nested</em>'.
     * @see com.ibm.etools.c.source.CBlock#getNested()
     * @see #getCBlock()
     * @generated
     */
    EReference getCBlock_Nested();

    /**
     * Returns the factory that creates the instances of the model. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the factory that creates the instances of the model.
     * @generated
     */
    SourceFactory getSourceFactory();

} //SourcePackage
